package org.cyrano.editor.listeners;

import java.util.ArrayList;
import java.util.List;

import javax.swing.event.EventListenerList;

public class SelectionManager {

  private static final SelectionManager instance = //
  new SelectionManager();

  // --------------------------------------------------------------------------------

  public static SelectionManager getInstance() {
    return instance;
  }

  // --------------------------------------------------------------------------------

  private EventListenerList eventListenerList = //
  new EventListenerList();

  private SelectionListenerProxy selectionListenerProxy = //
  new SelectionListenerProxy(eventListenerList);

  private List<Object> selectedObjects = new ArrayList<Object>();

  // --------------------------------------------------------------------------------

  private SelectionManager() {
    // Empty
  }

  // --------------------------------------------------------------------------------

  public List<Object> getSelectedObjects() {
    return selectedObjects;
  }

  // --------------------------------------------------------------------------------

  public void add(Object object) {
    selectedObjects.add(object);

    selectionListenerProxy.fireSelectionEvent( //
        new SelectionEvent(this, selectedObjects));
  }

  // --------------------------------------------------------------------------------

  public void clear() {
    selectedObjects.clear();

    selectionListenerProxy.fireSelectionEvent( //
        new SelectionEvent(this, selectedObjects));
  }

  // --------------------------------------------------------------------------------

  public SelectionListenerProxy getSelectionListenerProxy() {
    return selectionListenerProxy;
  }
}
