package org.cyrano.editor.parts;

import org.cyrano.timetable.ui.figures.SlotEditPart;
import org.cyrano.timetable.ui.figures.SlotViewPart;
import org.cyrano.timetable.ui.figures.TimeTableEditPart;
import org.cyrano.timetable.ui.figures.TimeTableViewPart;
import org.cyrano.timetable.ui.model.timetable.Root;
import org.cyrano.timetable.ui.model.timetable.Slot;

public class PartsFactory {

  public PartsFactory() {
    // Empty
  }

  // --------------------------------------------------------------------------------

  public void bindPartsFor(Object model, PartsRegister partsRegister) {
    if (model instanceof Root) {
      EditPart editPart = new TimeTableEditPart(partsRegister);
      ViewPart viewPart = new TimeTableViewPart(partsRegister);

      partsRegister.bind(model, editPart, viewPart);
      return;
    }

    if (model instanceof Slot) {
      EditPart editPart = new SlotEditPart(partsRegister);
      ViewPart viewPart = new SlotViewPart(partsRegister);

      partsRegister.bind(model, editPart, viewPart);
      return;
    }
  }
}
