package org.cyrano.editor.tool;

import java.awt.Color;
import java.awt.Graphics2D;

public class RectangleHFeedback implements EditPolicyFeedback {

  @Override
  public void paint(Graphics2D g2d, //
      EditPolicyMouseHandler editPolicyMouseHandler) {

    RectangleMouseHandler rmh = //
    (RectangleMouseHandler) editPolicyMouseHandler;

    if (rmh.getDraggedPt() == null) {
      return;
    }

    int newH = rmh.getDraggedPt().y - rmh.getDraggedFg().getRect().y + //
        rmh.getDraggedFg().getRect().h - rmh.getDraggedDy();

    if (newH >= 0) {
      g2d.setColor(Color.LIGHT_GRAY);
      g2d.fillRect( //
          rmh.getDraggedFg().getRect().x, rmh.getDraggedFg().getRect().y, //
          rmh.getDraggedFg().getRect().w, newH);
      g2d.setColor(Color.DARK_GRAY);
      g2d.drawRect( //
          rmh.getDraggedFg().getRect().x, rmh.getDraggedFg().getRect().y, //
          rmh.getDraggedFg().getRect().w, newH);
    } else {
      newH *= -1;
      g2d.setColor(Color.LIGHT_GRAY);
      g2d.fillRect(
      //
          rmh.getDraggedFg().getRect().x, rmh.getDraggedFg().getRect().y - newH, //
          rmh.getDraggedFg().getRect().w, newH);
      g2d.setColor(Color.DARK_GRAY);
      g2d.drawRect(
      //
          rmh.getDraggedFg().getRect().x, rmh.getDraggedFg().getRect().y - newH, //
          rmh.getDraggedFg().getRect().w, newH);
    }
  }
}
