package org.cyrano.gimp.palette;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class GimpPalette {

  private List<Color> colorList = new ArrayList<Color>();

  // --------------------------------------------------------------------------------

  public GimpPalette() {
    // Empty
  }

  // --------------------------------------------------------------------------------

  public void read(InputStream is) throws Exception {
    BufferedReader rd = new BufferedReader(new InputStreamReader(is));

    readUntil(rd, "#");

    String line;

    while ((line = rd.readLine()) != null) {
      line = line.trim();

      if (line.startsWith("#")) {
        continue;
      }

      if (line.equals("")) {
        continue;
      }

      String[] values = line.split("(\\s)+");

      int r = Integer.parseInt(values[0]);
      int g = Integer.parseInt(values[1]);
      int b = Integer.parseInt(values[2]);

      colorList.add(new Color(r, g, b));
    }
  }

  // --------------------------------------------------------------------------------

  private void readUntil(BufferedReader rd, String until) throws IOException {
    String line;

    while ((line = rd.readLine()) != null) {
      line = line.trim();

      if (line.equals(until)) {
        break;
      }
    }
  }

  // --------------------------------------------------------------------------------

  public List<Color> getColorList() {
    return colorList;
  }
}
