package org.cyrano.gimp.palette;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;

public class SequentialColorMap {

  private Map<Object, Color> colorByObjectMap = //
  new HashMap<Object, Color>();

  private GimpPalette gimpPalette;

  private int index = 0;

  // --------------------------------------------------------------------------------

  public SequentialColorMap(GimpPalette gimpPalette) {
    this.gimpPalette = gimpPalette;
  }

  // --------------------------------------------------------------------------------

  public Color getColorFor(Object object) {
    Color ret = colorByObjectMap.get(object);

    if (ret == null) {
      ret = gimpPalette.getColorList().get( //
          (index++) % gimpPalette.getColorList().size());

      colorByObjectMap.put(object, ret);
    }

    return ret;
  }

  // --------------------------------------------------------------------------------

  public void reset() {
    colorByObjectMap.clear();

    index = 0;
  }
}
