package org.cyrano.timetable.ui.command;

import java.util.ArrayList;
import java.util.List;

import org.cyrano.editor.listeners.Command;
import org.cyrano.timetable.ui.model.timetable.Room;
import org.cyrano.timetable.ui.model.timetable.Slot;

public class ClearRoomFromSlotCommand implements Command {

  private final List<Slot> slotList = new ArrayList<Slot>();

  private final Room room;

  // --------------------------------------------------------------------------------

  public ClearRoomFromSlotCommand(Room room) {
    this.room = room;

    for (Slot slot : room.getRoot().getAllChildrenSlots()) {
      if (slot.getRoom() == room) {
        slotList.add(slot);
      }
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public void redoCommand() {
    for (Slot slot : slotList) {
      slot.setRoom(null);
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public void undoCommand() {
    for (Slot slot : slotList) {
      slot.setRoom(room);
    }
  }

  // --------------------------------------------------------------------------------

  @Override
  public boolean canExecute() {
    return true;
  }
}
