package org.cyrano.timetable.ui.command;

import org.cyrano.editor.listeners.Command;
import org.cyrano.timetable.ui.model.base.BaseModel;

public class UpdateChildCommand implements Command {

  private BaseModel prevBaseModel;
  private BaseModel currBaseModel;
  private BaseModel nextBaseModel;

  // --------------------------------------------------------------------------------

  public UpdateChildCommand(// 
      BaseModel prevBaseModel, BaseModel currBaseModel, BaseModel nextBaseModel) {

    this.prevBaseModel = prevBaseModel;
    this.currBaseModel = currBaseModel;
    this.nextBaseModel = nextBaseModel;
  }

  // --------------------------------------------------------------------------------

  @Override
  public void redoCommand() {
    currBaseModel.shallowDataCopyFrom(nextBaseModel);
  }

  // --------------------------------------------------------------------------------

  @Override
  public void undoCommand() {
    currBaseModel.shallowDataCopyFrom(prevBaseModel);
  }

  // --------------------------------------------------------------------------------

  @Override
  public boolean canExecute() {
    return true;
  }
}
