package org.cyrano.timetable.ui.model.base;

import javax.swing.event.EventListenerList;

public class ModelChangeSupport {

  private final EventListenerList eventListenerList;

  // --------------------------------------------------------------------------------

  public ModelChangeSupport(EventListenerList eventListenerList) {
    this.eventListenerList = eventListenerList;
  }

  // --------------------------------------------------------------------------------

  public void addModelChangeListener(ModelChangeListener modelChangeListener) {

    eventListenerList.add( //
        ModelChangeListener.class, modelChangeListener);
  }

  // --------------------------------------------------------------------------------

  public void delModelChangeListener(ModelChangeListener modelChangeListener) {

    eventListenerList.remove( //
        ModelChangeListener.class, modelChangeListener);
  }

  // --------------------------------------------------------------------------------

  public ModelChangeListener[] getModelChangeListeners() {
    return eventListenerList.getListeners( //
        ModelChangeListener.class);
  }

  // --------------------------------------------------------------------------------

  public final void fireModelChange(ModelChangeEvent evt) {

    ModelChangeListener[] listeners = //
    getModelChangeListeners();

    for (int i = 0; i < listeners.length; i++) {
      listeners[i].modelChanged(evt);
    }
  }
}
