package org.cyrano.timetable.ui.view;

import org.cyrano.editor.parts.ContainerEditPart;
import org.cyrano.editor.parts.ContainerViewPart;
import org.cyrano.editor.parts.PartsRegister;
import org.cyrano.timetable.ui.model.timetable.Cour;
import org.cyrano.timetable.ui.model.timetable.Prof;
import org.cyrano.timetable.ui.model.timetable.Room;
import org.cyrano.timetable.ui.model.timetable.Root;
import org.cyrano.timetable.ui.model.timetable.Sect;
import org.cyrano.timetable.ui.model.timetable.Sems;
import org.cyrano.timetable.ui.model.timetable.Slot;
import org.cyrano.timetable.ui.model.visitor.ModelVisitor;

public class PartsBuilderVisitor implements ModelVisitor {

  private PartsRegister partsRegister;

  // --------------------------------------------------------------------------------

  public PartsBuilderVisitor(PartsRegister partsRegister) {
    this.partsRegister = partsRegister;
  }

  // --------------------------------------------------------------------------------
  // TimeTableVisitor
  // --------------------------------------------------------------------------------

  @Override
  public void visitRoot(Root root) {
    partsRegister.unbindAll();
    partsRegister.bind(root);
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitSems(Sems sems) {
    // Empty
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitProf(Prof prof) {
    // Empty
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitRoom(Room room) {
    // Empty
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitCour(Cour cour) {
    // Empty
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitSect(Sect sect) {
    // Empty
  }

  // --------------------------------------------------------------------------------

  @Override
  public void visitSlot(Slot slot) {
    partsRegister.unbind(slot);
    partsRegister.bind(slot);

    Root timeTable = slot.getRoot();

    ContainerEditPart timeTableEditPart = //
    (ContainerEditPart) partsRegister.getEditPartByModel(timeTable);
    timeTableEditPart.addChildren(partsRegister.getEditPartByModel(slot));

    ContainerViewPart timeTableViewPart = //
    (ContainerViewPart) partsRegister.getViewPartByModel(timeTable);
    timeTableViewPart.addChildren(partsRegister.getViewPartByModel(slot));
  }
}
